# -*- coding: utf-8 -*-
#######################################################################
#
#    YAMP - Yet Another Music Player - Box Display
#    Version 3.2.1 2017-04-03
#    Coded by  by AlfredENeumann (c)2016-2017
#    Support: www.vuplus-support.org
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    Thanks to the authors of Merlin Music Player and OpenPli Media
#    Player for ideas and code snippets
#
#######################################################################

from YampGlobals import *
from Components.Pixmap import Pixmap, MultiPixmap

class YampLCDRunningScreenV31(Screen):	  #for LCD 'Running Text'
	def __init__(self, session, parent):
		Screen.__init__(self, session, parent = parent)

		with open(os.path.join(yampDir, "skins", config.plugins.yampmusicplayer.yampSkin.value, "YampLcdRunning.xml"), 'r') as f:
			self.skin = f.read()

		self["lcdRunningText"] = StaticText("")
		self.onShow.append(self.__onShow)
		self.onHide.append(self.__onHide)
		self.lcdGetTextTimer = eTimer()
		if os.path.exists("/var/lib/dpkg/status"):
			self.lcdGetTextTimer_conn=self.lcdGetTextTimer.timeout.connect(self.selectionChanged)
		else:
			self.lcdGetTextTimer.callback.append(self.selectionChanged)

	def __onShow(self):
#		self.parent.list.connectSelChanged(self.selectionChanged)
		self.selectionChanged()

	def __onHide(self):
#		self.parent.list.disconnectSelChanged(self.selectionChanged)
		self.selectionChanged()
#		del self.lcdGetTextTimer

	def selectionChanged(self):
#		LOG('-----selectionChanged-----------', 'all')
		lcdRunningText = self.parent.getLcdText()
#		item = self.parent.getCurrentSelection()
		if lcdRunningText != self["lcdRunningText"].text:
			self["lcdRunningText"].text = lcdRunningText
		self.lcdGetTextTimer.start(1000)

	def setText(self, text, line):		#only for campatibility with standard LCD
		text = text


class YampLCDScreenV31(Screen):	#for Standard LCD 1 or 3 lines
	def __init__(self, session, parent):
		Screen.__init__(self, session, parent = parent)
		with open(os.path.join(yampDir, "skins", config.plugins.yampmusicplayer.yampSkin.value, "YampLCD.xml"), 'r') as f:
			self.skin = f.read()
		self["text1"] = Label("")
		self["text2"] = Label("")
		self["text3"] = Label("")
		self["coverArt"] = Pixmap()
		
	def setText(self, text, line):
		textleer = "    "
		text = text + textleer*10
		lcdMode = config.plugins.yampmusicplayer.yampLCD.value
		if lcdMode == 'cover': 
			self["text1"].setText("")
			self["text2"].setText("")
			self["text3"].setText("")
			return
		if line == 1:
			self["text1"].setText(text)
		if lcdMode == 'threelines' or lcdMode == 'cover3':
			if line == 2:
				self["text2"].setText(text)
			elif line == 3:
				self["text3"].setText(text)
		else:
			self["text2"].setText('')
			self["text3"].setText('')

	def setCover(self):
#		LOG('Yampscreen: YampLCDScreen: setCover: LcdConfig: %s' %(config.plugins.yampmusicplayer.yampLCD.value), 'err')
#		LOG('Yampscreen: YampLCDScreen: setCover: cover in..: %d' %('cover' in config.plugins.yampmusicplayer.yampLCD.value), 'err')
#		LOG('Yampscreen: YampLCDScreen: setCover: not cover in..: %d' %(not ('cover' in config.plugins.yampmusicplayer.yampLCD.value)), 'err')
		try:
			if not ('cover' in config.plugins.yampmusicplayer.yampLCD.value):
#				LOG('Yampscreen: YampLCDScreen: setCover: coverart hide', 'err')
				self["coverArt"].hide()
				return
		except: LOG('YampLCDScreen: setCover: hide: EXCEPT', 'err')
		try:
#			from Components.AVSwitch import AVSwitch
			from Tools.LoadPixmap import LoadPixmap
		except: LOG('Yampscreen: YampLCDScreen: setCover: import: EXCEPT', 'err')
		try: lcdCoverPixmap = LoadPixmap('/tmp/coverlcd.png')
		except: LOG('Yampscreen: YampLCDScreen: setCover: LoadPixmap: EXCEPT', 'err')
		try: self["coverArt"].instance.setPixmap(lcdCoverPixmap)
		except: LOG('Yampscreen: YampLCDScreen: setCover: setPixmap: EXCEPT', 'err')
		try: self["coverArt"].show()
		except: LOG('Yampscreen: YampLCDScreen: setCover: coverart show: EXCEPT', 'err')

		
